package applications.dns;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.datatransfer.*;
import applications.basics.ImageButton;

public class DNStool extends JFrame {

    private JLayeredPane pane;
    private JButton msgClear;
    private JTextArea msgBoard;
    


    String host;
    
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host.
       */
    public void setHost(String  v) {this.host = v;}
    
    
    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    
    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}
    

    private JMenuBar menu() {
	JMenuBar mb = new JMenuBar();
	JMenu fileMenu = new JMenu("File");
	      JMenuItem fm1 = new JMenuItem("Domain");
	      fm1.addActionListener(new ActionListener() {
		  public void actionPerformed(ActionEvent e) {
		      DomainGrid dg = new DomainGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(dg.getPreferredSize());
		      newFrame(dg,"Domain",true,true,false,true, 20,20, dim.width, dim.height, (JButton) dg.bp.cancel);
		      }});
              fileMenu.add(fm1);

	      fileMenu.add(new JSeparator());
	      JMenuItem fm5 = new JMenuItem("create Database");
	      fm5.addActionListener(new ActionListener() {
		  public void actionPerformed(ActionEvent e) {
		      generateDB();
		      }});
	      fileMenu.add(fm5);

	      fileMenu.add(new JSeparator());
	      JMenuItem fm4 = new JMenuItem("create DNS Server");
	      fm4.addActionListener(new ActionListener() {
		  public void actionPerformed(ActionEvent e) {
		      GenerateServer gs = new GenerateServer(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(gs.getPreferredSize());
		      newFrame(gs,"Generate Nameserver",true,true,false,true, 20,20, dim.width, dim.height, gs.close);
		      }});	
	      fileMenu.add(fm4);
	      fileMenu.add(new JSeparator());
	      JMenuItem fm3 = new JMenuItem("Exit");
	      fm3.addActionListener(new ActionListener() {
		  public void actionPerformed(ActionEvent e) {
		      System.exit(0);
		      }});
              fileMenu.add(fm3);

	    


       mb.add(fileMenu);

       JMenu editMenu       = new JMenu("Edit");
       JMenuItem em1 = new JMenuItem("Hosts");
       JMenuItem em2 = new JMenuItem("Alias");
       JMenuItem em3 = new JMenuItem("Mailexchange");
       JMenuItem em4 = new JMenuItem("Nameserver");
       JMenuItem em5 = new JMenuItem("Host Information");
       JMenuItem em6 = new JMenuItem("Forwarder");

       
       em1.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
		      HostGrid dg = new HostGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(dg.getPreferredSize());
		      newFrame(dg,"Hosts",true,true,false,true, 20,20, dim.width, dim.height, (JButton) dg.bp.cancel);
	       }});
       
       em2.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
		      AliasGrid dg = new AliasGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(dg.getPreferredSize());
		      newFrame(dg,"Alias",true,true,false,true, 20,20, dim.width, dim.height, (JButton)  dg.bp.cancel);
	       }});
       em3.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
		      MailexchangeGrid dg = new MailexchangeGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(dg.getPreferredSize());
		      newFrame(dg,"MX",true,true,false,true, 20,20, dim.width, dim.height, (JButton) dg.bp.cancel);
	       }});
              
       em4.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
		      NameserverGrid dg = new NameserverGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(dg.getPreferredSize());
		      newFrame(dg,"Nameserver",true,true,false,true, 20,20, dim.width, dim.height, (JButton) dg.bp.cancel);
	       }});
       

       em5.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	      	      HostinformationGrid dg = new HostinformationGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(dg.getPreferredSize());
		      newFrame(dg,"Hostinformation",true,true,false,true, 20,20, dim.width, dim.height,(JButton) dg.bp.cancel); 

	       }});
       
       em6.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	      	      ForwarderGrid fg = new ForwarderGrid(getHost(),getUser(),getPassword());
		      Dimension dim = new Dimension(fg.getPreferredSize());
		      newFrame(fg,"Forwarder",true,true,false,true, 20,20, dim.width, dim.height,(JButton) fg.bp.cancel); 

	       }});
       


       editMenu.add(em1);
       editMenu.add(em5);
       editMenu.add(em2);
       editMenu.add(em4);
       editMenu.add(em3);
       editMenu.add(em6);

       JMenu importMenu = new JMenu("Import");
       JMenuItem im1    = new JMenuItem("hosts-file");
       im1.setEnabled(false);
       JMenuItem im2    = new JMenuItem("DNS-DB");
       im2.setEnabled(false);
       im1.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	       importHosts();
	       }});
       im2.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	       importDB();
	       }});

       importMenu.add(im1);
       importMenu.add(im2);
       
       editMenu.add(importMenu);

       JMenu helpMenu = new JMenu("Help");
       JMenuItem hm1 = new JMenuItem("Help");
       helpMenu.add(hm1);
       hm1.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	       }});
       
       JMenuItem hm2 = new JMenuItem("About");
       helpMenu.add(hm2);
       hm2.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	       }});
       



       mb.add(fileMenu);
       mb.add(editMenu);
       mb.add(Box.createHorizontalGlue());
       mb.add(helpMenu);       
	  
       return mb;
    }

    private void importHosts() {



    }


    private void importDB() {


    }

    public void close() { this.dispose();}


    private void generateDB() {
	CreateDB cdb = new CreateDB(getHost(), getUser(), getPassword());
	message(cdb.getMessage());
	
    }


    private void message(String m) {
	msgBoard.append(m);
	msgBoard.updateUI();

    }



    private void initMsgBoard() {

	JPanel mPanel = new JPanel();
	mPanel.setLayout(new BorderLayout());

	msgClear = new JButton("Clear");
	msgClear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		msgBoard.setText("");
		}});
	
	JPanel mbPanel = new JPanel();
	mbPanel.add(msgClear);

	msgBoard = new JTextArea(10,10);
	msgBoard.setEditable(false);
	JScrollPane scp = new JScrollPane(msgBoard);

	mPanel.add("Center",scp);
	mPanel.add("South",mbPanel);
	newFrame(mPanel,"Message",true,false,false,true,50,50,100,100,null);

    }
    public DNStool(String host, String user, String password) {

	super("Fredy's DNS-Tool");


	setHost(host);
	setUser(user);
	setPassword(password);

	pane = new JDesktopPane();
	pane.setOpaque(false);



        this.getContentPane().setLayout(new BorderLayout());
	this.getContentPane().add("North",menu());
        this.getContentPane().add("Center",pane);

	this.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeactivated(WindowEvent e) {}
	    public void windowDeiconified(WindowEvent e) {}
	    public void windowIconified(WindowEvent e) {}
	    public void windowOpened(WindowEvent e) {}});
	
	initMsgBoard();
	this.pack();
	this.setSize(600,400);
	this.setVisible(true);
    }

      private void newFrame (JComponent panel, String title, boolean resizable, boolean closable, boolean maximizable, boolean iconifiable, int x, int y, int width, int height,JButton cancel) {
      
       final JInternalFrame frame;
       Container contentPane;
 
       frame = new JInternalFrame(title, resizable, closable, maximizable, iconifiable);
       contentPane = frame.getContentPane();
       contentPane.setLayout(new BorderLayout());      

       JScrollPane scrollpane = new JScrollPane(panel);

       scrollpane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
       scrollpane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);

       contentPane.add("Center",scrollpane);
       //contentPane.add("Center",panel);
       if ( cancel != null ) {
	   cancel.addActionListener(new ActionListener() {
	   public void actionPerformed(ActionEvent e) {
	       frame.dispose();
	       }});
       }
      // dimension JInternalFrame TEST
       Dimension dim = contentPane.getPreferredSize();
       frame.setBounds(x,y, dim.width+20, dim.height+35);

       pane.add(frame,4);
       frame.setVisible(true);
       frame.moveToFront();
       
      
      }


    public static void main(String args[]) {

	if ( args.length != 3 ) {
	    System.out.println("Syntax: java applications.dns.DNStool host user password");
	    System.exit(0);
	}
	DNStool d = new DNStool(args[0],args[1],args[2]);
    }
}
