package applications.dns;

/** this has been generated by Fredy's Admin-Tool for SQL-Databases
 *  this is a Swing-Form

 *  Date: 2000-11-26
 * 
 *  Table:    forwarder
 *  Database: dns
 *
 *  Admin is under GPL

  *  it uses Kai Tdter's JCalendar Bean

  *
 *  Fredy Fischer
 *  Hulmenweg 36
 *  8405 Winterthur
 *  Switzerland
 *
 * se-afs@dial.eunet.ch
 *
 **/

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.datatransfer.*;
import applications.basics.ButtonPanel;
import applications.basics.sqlTable;
import applications.basics.CalendarField;
import applications.basics.JTextFieldFilter;
import applications.basics.DBcomboBox;

public  class ForwarderGrid  extends JTabbedPane {

    public JTable list;
    private JPanel     listPanel;
    private JComboBox  search;
    private JCheckBox  exact;
    private JTextField searchString;

    private DBcomboBox domain;
    private JTextField hostname;
    public ButtonPanel bp;



    String ahost;
  
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getAHost() {return ahost;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host
       */
    public void setAHost(String  v) {this.ahost = v;}
    
    String auser;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getAUser() {return auser;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setAUser(String  v) {this.auser = v;}
    
    String apassword;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getAPassword() {return apassword;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setAPassword(String  v) {this.apassword = v;}

    public ForwarderGrid (String ahost, String auser, String apassword) {

	setAHost(ahost);
	setAUser(auser);
	setAPassword(apassword);

	this.add("Form",formPanel());
	this.add("Search",searchPanel());
    }

    private JPanel formPanel() {

    domain   = new DBcomboBox(getAHost(),getAUser(),getAPassword(),"dns","select name from domain order by name");
    domain.setSelectedIndex(0); 
    hostname = new JTextField("",25);

	JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());
	bp = new ButtonPanel();	
	panel.add("South",bp);

	bp.insert.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		insert(getRow());
		}});
	bp.delete.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		delete(getRow());
		}});
	bp.update.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		update(getRow());
		}});
	bp.clear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		clear();
		}});
	


	JPanel gridPanel = new JPanel();
	gridPanel.setLayout(new GridBagLayout());

	GridBagConstraints gbc;
	Insets insets = new Insets(5,5,5,5);
        JScrollPane fScrollPane;


	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Domain"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(domain,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Forwarders IP"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(hostname,gbc);

	JScrollPane scrollpane = new JScrollPane(gridPanel);

	panel.add("Center",scrollpane);

	return panel;

    }


    private JPanel searchPanel() {

	final JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());

   final JPanel panel2 = new JPanel();
	panel2.setLayout(new FlowLayout());

	listPanel = new JPanel();

	String[] items = {        "domain",
        "hostname",
	};
	
	search = new JComboBox(items);
	exact  = new JCheckBox("exact search");
	exact.setSelected(true);
	searchString = new JTextField("",20);
	JButton doIt = new JButton("Search");
	doIt.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String query = "select * from forwarder where ";
		String sel   = (String)search.getSelectedItem();
		int    ind   = search.getSelectedIndex();
		query = query + sel + " ";
		if (exact.isSelected()) {
		   query = query + "  = ";
		} else { query  = query + " like "; }
	        String s = searchString.getText();
		switch (ind) {
		case 0:
		    query = query + "'" + s + "'";
		    break;
		case 1:
		    query = query + "'" + s + "'";
		    break;
		default:
		    ;
		}
		query = query + " order by " + sel;
		panel.remove(listPanel);
           final sqlTable st = new sqlTable(getAHost(), getAUser(), getAPassword(),"dns",query);
		JScrollPane scp = new JScrollPane(st);
		Dimension d = new Dimension();
		d = panel.getSize();
 	        Integer intx = new Integer(d.width);
	        Integer inty = new Integer(d.height);
	        double fx = intx.floatValue() * 0.95;
	        double fy = inty.floatValue() * 0.65;
	        Double dfx = new Double(fx);
	        Double dfy = new Double(fy);
		d.setSize(dfx.intValue(),dfy.intValue());
		st.tableView.setPreferredScrollableViewportSize(d);
		listPanel = new JPanel();
		listPanel.add(scp);
		panel.add("South",listPanel);
		panel.updateUI();

		// as well there is needed a List Selection Listener
		st.tableView.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
		    public void valueChanged(ListSelectionEvent e) {
		ForwarderRow k = new ForwarderRow(getAHost(), getAUser(),getAPassword());

			Integer i = new Integer(0);
			Float f = new Float(0);
			Double dbl = new Double(0);
			k.setDomain((String)st.tableView.getValueAt(st.tableView.getSelectedRow(),0));
			k.setHostname((String)st.tableView.getValueAt(st.tableView.getSelectedRow(),1));


			setRow(k);
		    }});
		}});
	


	panel2.add(search);
	panel2.add(searchString);
	panel2.add(exact);
	panel2.add(doIt);
	panel2.setBorder(BorderFactory.createEtchedBorder());

	panel.add("North",panel2);
	panel.add("Center",listPanel);
	

	return panel;

    }


    public ForwarderRow getRow() {

	     ForwarderRow k = new ForwarderRow(getAHost(), getAUser(), getAPassword());

	k.setDomain(domain.getText());
	k.setHostname(hostname.getText());
   return k;

   }


    public void insert(ForwarderRow k) { msg(k.insert()); }
    public void update(ForwarderRow k) { msg(k.update()); }
    public void delete(ForwarderRow k) { 
	String string1 = "Yes";
	String string2 = "No";
	Object[] options = {string1, string2};
	int n = JOptionPane.showOptionDialog(null,
                              "Do you really want to delete?",
                               "Delete  ?",
                              JOptionPane.YES_NO_OPTION,
                              JOptionPane.QUESTION_MESSAGE,
                              null,     //don't use a custom Icon
                              options,  //the titles of buttons
                              string2); //the title of the default button
	     if (n == JOptionPane.YES_OPTION) {
		 String s = k.delete();
		 if (s.startsWith("ok")) {
		     clear();
		 } else { msg(s);}
	     }
    }

    private void msg(String s) {
	if (  ! s.startsWith("ok") )  JOptionPane.showMessageDialog(null, s,"Message",JOptionPane.WARNING_MESSAGE);
    }

    public void clear() {
		domain.setSelectedIndex(0);
		hostname.setText("");
    }

    public void setRow(ForwarderRow k) {

	domain.setSelectedItem(k.getDomain());
	hostname.setText(k.getHostname());

   }

    public static void main(String args[]) {

	if (args.length != 3) {
	    System.out.println("Syntax: java applications.dns.ForwarderGrid host user password");
	    System.exit(0);
	}
	ForwarderGrid kg = new ForwarderGrid(args[0], args[1], args[2]);
	JFrame frame = new JFrame("Forwarder Form");
	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().add("Center",kg);
	frame.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
            public void windowDeactivated(WindowEvent e) {}
            public void windowDeiconified(WindowEvent e) {}
            public void windowIconified(WindowEvent e) {}
            public void windowOpened(WindowEvent e) {}});
	kg.bp.cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	frame.pack();
	frame.setVisible(true);
	
    }
}
