package applications.dns;

/** this has been generated by Fredy's Admin-Tool for SQL-Databases
 *  Date: 2000-11-26
 * 
 *  RDBMS:    MySQL 
 *  Table:    forwarder
 *  Database: dns
 *
 *  Admin is under GPL
 *
 *  Fredy Fischer
 *  Hulmenweg 36
 *  8405 Winterthur
 *  Switzerland
 *
 * se-afs@dial.eunet.ch
 *
 **/

import java.sql.*;
import java.util.Calendar;
import applications.basics.t_connect;

public class ForwarderRow { 
    private  ResultSet sqlresult;
    private  t_connect con;
    
    String ahost;
  
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getAHost() {return ahost;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host
       */
    public void setAHost(String  v) {this.ahost = v;}
    
    String auser;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getAUser() {return auser;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setAUser(String  v) {this.auser = v;}
    
    String apassword;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getAPassword() {return apassword;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setAPassword(String  v) {this.apassword = v;}


    String database;
    
    /**
       * Get the value of database.
       * @return Value of database.
       */
    public String getDatabase() {return database;}
    
    /**
       * Set the value of database.
       * @param v  Value to assign to database.
       */
    public void setDatabase(String  v) {this.database = v;}

       String domain;

    /**
       * Set the value of domain.
       * @param v  Value to assign to domain .
       */
       public void setDomain(String  v) { this.domain = v;}

    /**
       * Get the value of domain.
       * @return  Value of domain .
       */
       public String getDomain() {return domain;} 

       String hostname;

    /**
       * Set the value of hostname.
       * @param v  Value to assign to hostname .
       */
       public void setHostname(String  v) { this.hostname = v;}

    /**
       * Get the value of hostname.
       * @return  Value of hostname .
       */
       public String getHostname() {return hostname;} 

    String query;
    
    /**
       * Get the value of query.
       * @return Value of query.
       */
    public String getQuery() {return query;}
    
    /**
       * Set the value of query.
       * @param v  Value to assign to query.
       */
    public void setQuery(String  v) {this.query = v;}

    private String toDay() {

	        Calendar c = Calendar.getInstance();

    	return  Integer.toString(c.get(Calendar.YEAR)) + "-" + 
                 Integer.toString(c.get(Calendar.MONTH)+1)+ "-" + 
                 Integer.toString(c.get(Calendar.DATE));
     }
    public ForwarderRow(String ahost, String auser, String apassword) {

	setDatabase("dns");

	setAHost(ahost);
	setAUser(auser);
	setAPassword(apassword);

	setDomain("");
	setHostname("");


    }

    public ForwarderRow(String ahost, String auser, String apassword,String domain,String hostname) {

	setDatabase("dns");

	setAHost(ahost);
	setAUser(auser);
	setAPassword(apassword);

	setDomain(domain);
	setHostname(hostname);


    }    private String execQuery() {

	t_connect c = new t_connect(getAHost(), getAUser(), getAPassword(), getDatabase());
	if (c.getError() != null) {
	    return "Connection Error: "+ c.getError();
	}	


        try {
	    int records = c.stmt.executeUpdate(getQuery());
	    c.close(); 	
	} catch (Exception e) {
	    return e.getMessage().toString();
	}
	return "ok";
    }

    private String selectQuery() {

	con = new t_connect(getAHost(), getAUser(), getAPassword(), getDatabase());
	if (con.getError() != null) {
	    return "Connection Error: "+ con.getError();
	}

	try {
          sqlresult = con.stmt.executeQuery(getQuery());

	} catch (Exception e) {
	    return e.getMessage().toString();
	}
	return "ok";
    }


    public ForwarderRow next() {

	ForwarderRow k = new ForwarderRow(getAHost(),getAUser(),getAPassword());
	try {
	    if (sqlresult.next()) {
               k.setDomain(sqlresult.getString("domain"));
               k.setHostname(sqlresult.getString("hostname"));
		return k;
	    } else 
		{ con.close();
		  return null; 
		}
	} catch  (Exception e) {
          return null;
	}
    }
    public String insert() {

      setQuery ("insert into forwarder (domain, hostname) values (" +"'" + getDomain() +"'" + ", " + "'" + getHostname() +"'" + ")");  
       return execQuery();
 
    }


    public String update() {

	setQuery("update forwarder set domain = " + "'" + getDomain() + "'" + ", hostname = " + "'" + getHostname() + "'" + " where  (domain =  " + "'" + getDomain() + "'"  + " and hostname =  " + "'" + getHostname() + "'"  + ")" );
        return execQuery();
    }


    public String delete() {

 	setQuery("delete from forwarder where  (domain =  " + "'" + getDomain() + "'"  + " and hostname =  " + "'" + getHostname() + "'"  + ")");
        return execQuery();
    }

    public String searchAll() {

 	setQuery("select * from forwarder");
        return selectQuery();
    }

    // if you set exact to true, it will return exact the corresponding row
    // if you set exact to false,all rows corresponding  like-Statement will be returned

    public String searchByDomain(String domain, boolean exact) {

	String e;
	if ( exact ) { 
	   e = "="; } else {
	   e = "like"; }
 	setQuery("select * from forwarder where domain " + e + " " + "'" + domain + "'" + " order by domain");
	return selectQuery();
    }


    // if you set exact to true, it will return exact the corresponding row
    // if you set exact to false,all rows corresponding  like-Statement will be returned

    public String searchByHostname(String hostname, boolean exact) {

	String e;
	if ( exact ) { 
	   e = "="; } else {
	   e = "like"; }
 	setQuery("select * from forwarder where hostname " + e + " " + "'" + hostname + "'" + " order by hostname");
	return selectQuery();
    }


}
